



<!DOCTYPE html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      <meta http-equiv="x-ua-compatible" content="ie=edge">
      
      
      
      
        <meta name="lang:clipboard.copy" content="Copy to clipboard">
      
        <meta name="lang:clipboard.copied" content="Copied to clipboard">
      
        <meta name="lang:search.language" content="en">
      
        <meta name="lang:search.pipeline.stopwords" content="True">
      
        <meta name="lang:search.pipeline.trimmer" content="True">
      
        <meta name="lang:search.result.none" content="No matching documents">
      
        <meta name="lang:search.result.one" content="1 matching document">
      
        <meta name="lang:search.result.other" content="# matching documents">
      
        <meta name="lang:search.tokenizer" content="[\s\-]+">
      
      <link rel="shortcut icon" href="../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-0.17.3, mkdocs-material-2.7.2">
    
    
      
        <title>Backups - HomelabOS</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/application.8d40d89b.css">
      
    
    
      <script src="../../assets/javascripts/modernizr.1aa3b519.js"></script>
    
    
      <link href="https://fonts.gstatic.com" rel="preconnect" crossorigin>
      
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,400i,700|Roboto+Mono">
        <style>body,input{font-family:"Roboto","Helvetica Neue",Helvetica,Arial,sans-serif}code,kbd,pre{font-family:"Roboto Mono","Courier New",Courier,monospace}</style>
      
      <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">
    
    
    
  </head>
  
    <body dir="ltr">
  
    <svg class="md-svg">
      <defs>
        
        
          <svg xmlns="http://www.w3.org/2000/svg" width="500" height="500"
    viewBox="0 0 500 500" id="gitlab">
  <g transform="translate(156.197863, 1.160267)">
  	<path fill="currentColor"
        d="M93.667,473.347L93.667,473.347l90.684-279.097H2.983L93.667,
          473.347L93.667,473.347z" />
  </g>
  <g transform="translate(28.531199, 1.160800)" opacity="0.7">
  	<path fill="currentColor"
        d="M221.333,473.345L130.649,194.25H3.557L221.333,473.345L221.333,
          473.345z" />
  </g>
  <g transform="translate(0.088533, 0.255867)" opacity="0.5">
  	<path fill="currentColor"
        d="M32,195.155L32,195.155L4.441,279.97c-2.513,7.735,0.24,16.21,6.821,
          20.99l238.514,173.29 L32,195.155L32,195.155z" />
  </g>
  <g transform="translate(29.421866, 280.255593)">
  	<path fill="currentColor"
        d="M2.667-84.844h127.092L75.14-252.942c-2.811-8.649-15.047-8.649-17.856,
          0L2.667-84.844 L2.667-84.844z" />
  </g>
  <g transform="translate(247.197860, 1.160800)" opacity="0.7">
  	<path fill="currentColor"
        d="M2.667,473.345L93.351,194.25h127.092L2.667,473.345L2.667,
          473.345z" />
  </g>
  <g transform="translate(246.307061, 0.255867)" opacity="0.5">
  	<path fill="currentColor"
        d="M221.334,195.155L221.334,195.155l27.559,84.815c2.514,7.735-0.24,
          16.21-6.821,20.99 L3.557,474.25L221.334,195.155L221.334,195.155z" />
  </g>
  <g transform="translate(336.973725, 280.255593)">
  	<path fill="currentColor"
        d="M130.667-84.844H3.575l54.618-168.098c2.811-8.649,15.047-8.649,
          17.856,0L130.667-84.844 L130.667-84.844z" />
  </g>
</svg>
        
      </defs>
    </svg>
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="search" autocomplete="off">
    <label class="md-overlay" data-md-component="overlay" for="drawer"></label>
    
      <a href="#homelabos-backups" tabindex="1" class="md-skip">
        Skip to content
      </a>
    
    
      <header class="md-header" data-md-component="header">
  <nav class="md-header-nav md-grid">
    <div class="md-flex">
      <div class="md-flex__cell md-flex__cell--shrink">
        <a href="../.." title="HomelabOS" class="md-header-nav__button md-logo">
          
            <i class="md-icon">home</i>
          
        </a>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        <label class="md-icon md-icon--menu md-header-nav__button" for="drawer"></label>
      </div>
      <div class="md-flex__cell md-flex__cell--stretch">
        <div class="md-flex__ellipsis md-header-nav__title" data-md-component="title">
          
            
              <span class="md-header-nav__topic">
                HomelabOS
              </span>
              <span class="md-header-nav__topic">
                Backups
              </span>
            
          
        </div>
      </div>
      <div class="md-flex__cell md-flex__cell--shrink">
        
          
            <label class="md-icon md-icon--search md-header-nav__button" for="search"></label>
            
<div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="query" data-md-state="active">
      <label class="md-icon md-search__icon" for="search"></label>
      <button type="reset" class="md-icon md-search__icon" data-md-component="reset" tabindex="-1">
        &#xE5CD;
      </button>
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="result">
          <div class="md-search-result__meta">
            Type to start searching
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
          
        
      </div>
      
        <div class="md-flex__cell md-flex__cell--shrink">
          <div class="md-header-nav__source">
            


  


  <a href="https://gitlab.com/NickBusey/HomelabOS/" title="Go to repository" class="md-source" data-md-source="gitlab">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#gitlab" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      Gitlab
    </div>
  </a>

          </div>
        </div>
      
    </div>
  </nav>
</header>
    
    <div class="md-container">
      
        
      
      
      <main class="md-main">
        <div class="md-main__inner md-grid" data-md-component="container">
          
            
              <div class="md-sidebar md-sidebar--primary" data-md-component="navigation">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    <nav class="md-nav md-nav--primary" data-md-level="0">
  <label class="md-nav__title md-nav__title--site" for="drawer">
    <span class="md-nav__button md-logo">
      
        <i class="md-icon">home</i>
      
    </span>
    HomelabOS
  </label>
  
    <div class="md-nav__source">
      


  


  <a href="https://gitlab.com/NickBusey/HomelabOS/" title="Go to repository" class="md-source" data-md-source="gitlab">
    
      <div class="md-source__icon">
        <svg viewBox="0 0 24 24" width="24" height="24">
          <use xlink:href="#gitlab" width="24" height="24"></use>
        </svg>
      </div>
    
    <div class="md-source__repository">
      Gitlab
    </div>
  </a>

    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      


  <li class="md-nav__item">
    <a href="../.." title="Home" class="md-nav__link">
      Home
    </a>
  </li>

    
      
      
      

  


  <li class="md-nav__item md-nav__item--active md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-2" type="checkbox" id="nav-2" checked>
    
    <label class="md-nav__link" for="nav-2">
      Setup
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-2">
        Setup
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../installation/" title="Installation" class="md-nav__link">
      Installation
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../gettingstarted/" title="Getting Started" class="md-nav__link">
      Getting Started
    </a>
  </li>

        
          
          
          

  


  <li class="md-nav__item md-nav__item--active">
    
    <input class="md-toggle md-nav__toggle" data-md-toggle="toc" type="checkbox" id="toc">
    
      
    
    
      <label class="md-nav__link md-nav__link--active" for="toc">
        Backups
      </label>
    
    <a href="./" title="Backups" class="md-nav__link md-nav__link--active">
      Backups
    </a>
    
      
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#get-access-to-an-s3-bucket" title="Get access to an S3 Bucket" class="md-nav__link">
    Get access to an S3 Bucket
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#set-up-your-own-s3" title="Set up your own S3" class="md-nav__link">
    Set up your own S3
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#configure-the-backup-service" title="Configure the Backup Service" class="md-nav__link">
    Configure the Backup Service
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#restoring-backups" title="Restoring Backups" class="md-nav__link">
    Restoring Backups
  </a>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
    
  </li>

        
      </ul>
    </nav>
  </li>

    
      
      
      


  <li class="md-nav__item md-nav__item--nested">
    
      <input class="md-toggle md-nav__toggle" data-md-toggle="nav-3" type="checkbox" id="nav-3">
    
    <label class="md-nav__link" for="nav-3">
      Included Software
    </label>
    <nav class="md-nav" data-md-component="collapsible" data-md-level="1">
      <label class="md-nav__title" for="nav-3">
        Included Software
      </label>
      <ul class="md-nav__list" data-md-scrollfix>
        
        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/convos/" title="Convos" class="md-nav__link">
      Convos
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/darksky/" title="Darksky" class="md-nav__link">
      Darksky
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/dasher/" title="Dasher" class="md-nav__link">
      Dasher
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/emby/" title="Emby" class="md-nav__link">
      Emby
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/firefly/" title="Firefly III" class="md-nav__link">
      Firefly III
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/gitea/" title="Gitea" class="md-nav__link">
      Gitea
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/grafana/" title="Grafana" class="md-nav__link">
      Grafana
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/homeassistant/" title="Home Assistant" class="md-nav__link">
      Home Assistant
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/influxdb/" title="InfluxDB" class="md-nav__link">
      InfluxDB
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/nextcloud/" title="NextCloud" class="md-nav__link">
      NextCloud
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/paperless/" title="Paperless" class="md-nav__link">
      Paperless
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/portainer/" title="Portainer" class="md-nav__link">
      Portainer
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/terminal/" title="Terminal" class="md-nav__link">
      Terminal
    </a>
  </li>

        
          
          
          


  <li class="md-nav__item">
    <a href="../../software/transmission/" title="Transmission" class="md-nav__link">
      Transmission
    </a>
  </li>

        
      </ul>
    </nav>
  </li>

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              <div class="md-sidebar md-sidebar--secondary" data-md-component="toc">
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    
<nav class="md-nav md-nav--secondary">
  
  
    
  
  
    <label class="md-nav__title" for="toc">Table of contents</label>
    <ul class="md-nav__list" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#get-access-to-an-s3-bucket" title="Get access to an S3 Bucket" class="md-nav__link">
    Get access to an S3 Bucket
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#set-up-your-own-s3" title="Set up your own S3" class="md-nav__link">
    Set up your own S3
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#configure-the-backup-service" title="Configure the Backup Service" class="md-nav__link">
    Configure the Backup Service
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#restoring-backups" title="Restoring Backups" class="md-nav__link">
    Restoring Backups
  </a>
  
</li>
      
      
      
      
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content">
            <article class="md-content__inner md-typeset">
              
                
                  <a href="https://gitlab.com/NickBusey/HomelabOS/edit/master/docs/setup/backups.md" title="Edit this page" class="md-icon md-content__icon">&#xE3C9;</a>
                
                
                <h1 id="homelabos-backups">HomelabOS Backups</h1>
<p>HomelabOS automatically backs itself in a smart, incremental, encrypted way to any S3 compatible storage provider, using <a href="https://restic.net/">Restic</a>.</p>
<p>This is in addition to and separate from the Backup service included within HomelabOS, which backs up your personal computers to the HomelabOS servers.</p>
<h2 id="get-access-to-an-s3-bucket">Get access to an S3 Bucket</h2>
<p>Ideally you want your backups to be offsite, so an S3 bucket is not set up by default for you on your HomlabOS machine. Since we use encrypted backups, you can easily have a friend or enemy host an S3 server for you, and as long as they don't get your backup password, everything will be safe. We recommend generating a very secure password for your backup password.</p>
<p>Or you could pay Amazon and use their S3 service, if you're into that sort of thing.</p>
<h2 id="set-up-your-own-s3">Set up your own S3</h2>
<p>We recommend Minio.</p>
<pre><code>brew install minio/stable/minio
minio server /data
</code></pre>

<p>Create a bucket called <code>homelabos</code>.</p>
<p>Of course keep in mind when self hosting your own S3, you likely want to keep good backups of the S3 data files as well.</p>
<h2 id="configure-the-backup-service">Configure the Backup Service</h2>
<p>Set your S3 path and keys in <code>host_vars/myserver</code>.</p>
<p>If you use minio for your S3 hosting, your s3_path should look something like <code>s3:http://192.168.1.212:9000/homelabos/</code></p>
<p>Once these are set, HomelabOS will back up all it's core data every night at 4 AM.</p>
<h2 id="restoring-backups">Restoring Backups</h2>
<p>Let's say your machine gets wiped, or you want to migrate to a new machine. To restore your most recent backup, simply run <code>make restore</code>. Then proceed with the normal install step of running <code>make</code> and boom, you have all your data back with a fully working HomelabOS setup.</p>
                
                  
                
              
              
                


              
            </article>
          </div>
        </div>
      </main>
      
        
<footer class="md-footer">
  
    <div class="md-footer-nav">
      <nav class="md-footer-nav__inner md-grid">
        
          <a href="../gettingstarted/" title="Getting Started" class="md-flex md-footer-nav__link md-footer-nav__link--prev" rel="prev">
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-back md-footer-nav__button"></i>
            </div>
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Previous
                </span>
                Getting Started
              </span>
            </div>
          </a>
        
        
          <a href="../../software/convos/" title="Convos" class="md-flex md-footer-nav__link md-footer-nav__link--next" rel="next">
            <div class="md-flex__cell md-flex__cell--stretch md-footer-nav__title">
              <span class="md-flex__ellipsis">
                <span class="md-footer-nav__direction">
                  Next
                </span>
                Convos
              </span>
            </div>
            <div class="md-flex__cell md-flex__cell--shrink">
              <i class="md-icon md-icon--arrow-forward md-footer-nav__button"></i>
            </div>
          </a>
        
      </nav>
    </div>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-footer-copyright">
        
        powered by
        <a href="http://www.mkdocs.org">MkDocs</a>
        and
        <a href="https://squidfunk.github.io/mkdocs-material/">
          Material for MkDocs</a>
      </div>
      
        
      
    </div>
  </div>
</footer>
      
    </div>
    
      <script src="../../assets/javascripts/application.b438e6c5.js"></script>
      
      <script>app.initialize({version:"0.17.3",url:{base:"../.."}})</script>
      
    
    
      
    
  </body>
</html>